Index: branches/2288_HeuristicLab.VariableInteractionNetworks/HeuristicLab.VariableInteractionNetworks/3.3/CreateTargetVariationExperiment.cs
===================================================================
--- branches/HeuristicLab.VariableInteractionNetworks/HeuristicLab.VariableInteractionNetworks/3.3/CreateTargetVariationExperiment.cs	(revision 15421)
+++ 	(revision )
@@ -1,71 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Collections.Generic;
-using System.Windows.Forms;
-using HeuristicLab.MainForm;
-using HeuristicLab.Optimization;
-using HeuristicLab.Optimizer;
-using HeuristicLab.Problems.DataAnalysis;
-
-namespace HeuristicLab.VariableInteractionNetworks {
-  internal class CreateTargetVariationExperiment : HeuristicLab.MainForm.WindowsForms.MenuItem, IOptimizerUserInterfaceItemProvider {
-    public override string Name {
-      get { return "Create Target Variation &Experiment"; }
-    }
-    public override IEnumerable<string> Structure {
-      get { return new string[] { "&Edit" }; }
-    }
-    public override int Position {
-      get { return 2300; }
-    }
-    public override string ToolTipText {
-      get { return "Create an experiment for varying the target variable"; }
-    }
-
-    protected override void OnToolStripItemSet(EventArgs e) {
-      ToolStripItem.Enabled = false;
-    }
-    protected override void OnActiveViewChanged(object sender, EventArgs e) {
-      IContentView activeView = MainFormManager.MainForm.ActiveView as IContentView;
-      bool enabled = false;
-      if (activeView != null && !activeView.Locked && activeView.Content != null) {
-        var algorithm = activeView.Content as IAlgorithm;
-        if (algorithm != null) {
-          var problem = algorithm.Problem;
-          // make sure the problem data specifies a target variable
-          enabled = problem is IRegressionProblem || problem is IClassificationProblem;
-        }
-      }
-      ToolStripItem.Enabled = enabled;
-    }
-
-    public override void Execute() {
-      IContentView activeView = MainFormManager.MainForm.ActiveView as IContentView;
-      if ((activeView != null) && (activeView.Content != null) && (activeView.Content is IOptimizer) && !activeView.Locked) {
-        using (CreateTargetVariationExperimentDialog dialog = new CreateTargetVariationExperimentDialog((IAlgorithm)activeView.Content)) {
-          if (dialog.ShowDialog() == DialogResult.OK) MainFormManager.MainForm.ShowContent(dialog.Experiment);
-        }
-      }
-    }
-  }
-}
Index: branches/2288_HeuristicLab.VariableInteractionNetworks/HeuristicLab.VariableInteractionNetworks/3.3/CreateTargetVariationExperimentDialog.Designer.cs
===================================================================
--- branches/HeuristicLab.VariableInteractionNetworks/HeuristicLab.VariableInteractionNetworks/3.3/CreateTargetVariationExperimentDialog.Designer.cs	(revision 15421)
+++ 	(revision )
@@ -1,217 +1,0 @@
-﻿namespace HeuristicLab.VariableInteractionNetworks
-{
-    partial class CreateTargetVariationExperimentDialog
-    {
-        /// <summary>
-        /// Required designer variable.
-        /// </summary>
-        private System.ComponentModel.IContainer components = null;
-
-        /// <summary>
-        /// Clean up any resources being used.
-        /// </summary>
-        /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
-        protected override void Dispose(bool disposing)
-        {
-            if (disposing && (components != null))
-            {
-                components.Dispose();
-            }
-            base.Dispose(disposing);
-        }
-
-        #region Windows Form Designer generated code
-
-        /// <summary>
-        /// Required method for Designer support - do not modify
-        /// the contents of this method with the code editor.
-        /// </summary>
-        private void InitializeComponent()
-        {
-      this.repetitionsNumericUpDown = new System.Windows.Forms.NumericUpDown();
-      this.repetitionsLabel = new System.Windows.Forms.Label();
-      this.cancelButton = new System.Windows.Forms.Button();
-      this.okButton = new System.Windows.Forms.Button();
-      this.combinationGroupSizeNumericUpDown = new System.Windows.Forms.NumericUpDown();
-      this.label1 = new System.Windows.Forms.Label();
-      this.combinationsLabel = new System.Windows.Forms.Label();
-      this.combinationCountLabel = new System.Windows.Forms.Label();
-      this.progressBar = new System.Windows.Forms.ProgressBar();
-      this.worker = new System.ComponentModel.BackgroundWorker();
-      ((System.ComponentModel.ISupportInitialize)(this.repetitionsNumericUpDown)).BeginInit();
-      ((System.ComponentModel.ISupportInitialize)(this.combinationGroupSizeNumericUpDown)).BeginInit();
-      this.SuspendLayout();
-      // 
-      // repetitionsNumericUpDown
-      // 
-      this.repetitionsNumericUpDown.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.repetitionsNumericUpDown.Location = new System.Drawing.Point(81, 12);
-      this.repetitionsNumericUpDown.Maximum = new decimal(new int[] {
-            1000000,
-            0,
-            0,
-            0});
-      this.repetitionsNumericUpDown.Minimum = new decimal(new int[] {
-            1,
-            0,
-            0,
-            0});
-      this.repetitionsNumericUpDown.Name = "repetitionsNumericUpDown";
-      this.repetitionsNumericUpDown.Size = new System.Drawing.Size(240, 20);
-      this.repetitionsNumericUpDown.TabIndex = 4;
-      this.repetitionsNumericUpDown.ThousandsSeparator = true;
-      this.repetitionsNumericUpDown.Value = new decimal(new int[] {
-            10,
-            0,
-            0,
-            0});
-      this.repetitionsNumericUpDown.Validated += new System.EventHandler(this.repetitionsNumericUpDown_Validated);
-      // 
-      // repetitionsLabel
-      // 
-      this.repetitionsLabel.AutoSize = true;
-      this.repetitionsLabel.Location = new System.Drawing.Point(12, 12);
-      this.repetitionsLabel.Name = "repetitionsLabel";
-      this.repetitionsLabel.Size = new System.Drawing.Size(63, 13);
-      this.repetitionsLabel.TabIndex = 5;
-      this.repetitionsLabel.Text = "&Repetitions:";
-      // 
-      // cancelButton
-      // 
-      this.cancelButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
-      this.cancelButton.DialogResult = System.Windows.Forms.DialogResult.Cancel;
-      this.cancelButton.Location = new System.Drawing.Point(246, 66);
-      this.cancelButton.Name = "cancelButton";
-      this.cancelButton.Size = new System.Drawing.Size(75, 23);
-      this.cancelButton.TabIndex = 9;
-      this.cancelButton.Text = "&Cancel";
-      this.cancelButton.UseVisualStyleBackColor = true;
-      this.cancelButton.Click += new System.EventHandler(this.cancelButton_Click);
-      // 
-      // okButton
-      // 
-      this.okButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
-      this.okButton.DialogResult = System.Windows.Forms.DialogResult.OK;
-      this.okButton.Location = new System.Drawing.Point(165, 66);
-      this.okButton.Name = "okButton";
-      this.okButton.Size = new System.Drawing.Size(75, 23);
-      this.okButton.TabIndex = 10;
-      this.okButton.Text = "&Ok";
-      this.okButton.UseVisualStyleBackColor = true;
-      this.okButton.Click += new System.EventHandler(this.okButton_Click);
-      // 
-      // combinationGroupSizeNumericUpDown
-      // 
-      this.combinationGroupSizeNumericUpDown.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.combinationGroupSizeNumericUpDown.Location = new System.Drawing.Point(81, 38);
-      this.combinationGroupSizeNumericUpDown.Maximum = new decimal(new int[] {
-            1000000,
-            0,
-            0,
-            0});
-      this.combinationGroupSizeNumericUpDown.Minimum = new decimal(new int[] {
-            1,
-            0,
-            0,
-            0});
-      this.combinationGroupSizeNumericUpDown.Name = "combinationGroupSizeNumericUpDown";
-      this.combinationGroupSizeNumericUpDown.Size = new System.Drawing.Size(240, 20);
-      this.combinationGroupSizeNumericUpDown.TabIndex = 4;
-      this.combinationGroupSizeNumericUpDown.ThousandsSeparator = true;
-      this.combinationGroupSizeNumericUpDown.Value = new decimal(new int[] {
-            10,
-            0,
-            0,
-            0});
-      this.combinationGroupSizeNumericUpDown.ValueChanged += new System.EventHandler(this.combinationGroupSizeNumericUpDown_Validated);
-      this.combinationGroupSizeNumericUpDown.Validating += new System.ComponentModel.CancelEventHandler(this.combinationGroupSizeNumericUpDown_Validating);
-      this.combinationGroupSizeNumericUpDown.Validated += new System.EventHandler(this.combinationGroupSizeNumericUpDown_Validated);
-      // 
-      // label1
-      // 
-      this.label1.AutoSize = true;
-      this.label1.Location = new System.Drawing.Point(12, 40);
-      this.label1.Name = "label1";
-      this.label1.Size = new System.Drawing.Size(60, 13);
-      this.label1.TabIndex = 5;
-      this.label1.Text = "&Group size:";
-      // 
-      // combinationsLabel
-      // 
-      this.combinationsLabel.AutoSize = true;
-      this.combinationsLabel.Location = new System.Drawing.Point(12, 71);
-      this.combinationsLabel.Name = "combinationsLabel";
-      this.combinationsLabel.Size = new System.Drawing.Size(73, 13);
-      this.combinationsLabel.TabIndex = 11;
-      this.combinationsLabel.Text = "Combinations:";
-      // 
-      // combinationCountLabel
-      // 
-      this.combinationCountLabel.AutoSize = true;
-      this.combinationCountLabel.Location = new System.Drawing.Point(91, 71);
-      this.combinationCountLabel.Name = "combinationCountLabel";
-      this.combinationCountLabel.Size = new System.Drawing.Size(0, 13);
-      this.combinationCountLabel.TabIndex = 12;
-      // 
-      // progressBar
-      // 
-      this.progressBar.Location = new System.Drawing.Point(15, 66);
-      this.progressBar.Name = "progressBar";
-      this.progressBar.Size = new System.Drawing.Size(144, 23);
-      this.progressBar.Step = 1;
-      this.progressBar.TabIndex = 13;
-      this.progressBar.Visible = false;
-      // 
-      // worker
-      // 
-      this.worker.WorkerReportsProgress = true;
-      this.worker.WorkerSupportsCancellation = true;
-      this.worker.DoWork += new System.ComponentModel.DoWorkEventHandler(this.worker_DoWork);
-      this.worker.ProgressChanged += new System.ComponentModel.ProgressChangedEventHandler(this.worker_ProgressChanged);
-      this.worker.RunWorkerCompleted += new System.ComponentModel.RunWorkerCompletedEventHandler(this.worker_RunWorkerCompleted);
-      // 
-      // CreateTargetVariationExperimentDialog
-      // 
-      this.AcceptButton = this.okButton;
-      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
-      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.CancelButton = this.cancelButton;
-      this.ClientSize = new System.Drawing.Size(333, 101);
-      this.Controls.Add(this.progressBar);
-      this.Controls.Add(this.combinationCountLabel);
-      this.Controls.Add(this.combinationsLabel);
-      this.Controls.Add(this.okButton);
-      this.Controls.Add(this.cancelButton);
-      this.Controls.Add(this.label1);
-      this.Controls.Add(this.repetitionsLabel);
-      this.Controls.Add(this.combinationGroupSizeNumericUpDown);
-      this.Controls.Add(this.repetitionsNumericUpDown);
-      this.MaximizeBox = false;
-      this.MinimizeBox = false;
-      this.Name = "CreateTargetVariationExperimentDialog";
-      this.ShowIcon = false;
-      this.Text = "Create Target Variation Experiment";
-      this.FormClosing += new System.Windows.Forms.FormClosingEventHandler(this.CreateTargetVariationExperimentDialog_FormClosing);
-      ((System.ComponentModel.ISupportInitialize)(this.repetitionsNumericUpDown)).EndInit();
-      ((System.ComponentModel.ISupportInitialize)(this.combinationGroupSizeNumericUpDown)).EndInit();
-      this.ResumeLayout(false);
-      this.PerformLayout();
-
-        }
-
-        #endregion
-
-        private System.Windows.Forms.NumericUpDown repetitionsNumericUpDown;
-        private System.Windows.Forms.Label repetitionsLabel;
-        private System.Windows.Forms.Button cancelButton;
-        private System.Windows.Forms.Button okButton;
-    private System.Windows.Forms.NumericUpDown combinationGroupSizeNumericUpDown;
-    private System.Windows.Forms.Label label1;
-    private System.Windows.Forms.Label combinationsLabel;
-    private System.Windows.Forms.Label combinationCountLabel;
-    private System.Windows.Forms.ProgressBar progressBar;
-    private System.ComponentModel.BackgroundWorker worker;
-  }
-}
Index: branches/2288_HeuristicLab.VariableInteractionNetworks/HeuristicLab.VariableInteractionNetworks/3.3/CreateTargetVariationExperimentDialog.cs
===================================================================
--- branches/HeuristicLab.VariableInteractionNetworks/HeuristicLab.VariableInteractionNetworks/3.3/CreateTargetVariationExperimentDialog.cs	(revision 15421)
+++ 	(revision )
@@ -1,213 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Collections.Generic;
-using System.ComponentModel;
-using System.Linq;
-using System.Windows.Forms;
-using HeuristicLab.Common;
-using HeuristicLab.MainForm;
-using HeuristicLab.Optimization;
-using HeuristicLab.Problems.DataAnalysis;
-
-namespace HeuristicLab.VariableInteractionNetworks {
-  public partial class CreateTargetVariationExperimentDialog : Form {
-    public Experiment Experiment { get; private set; }
-
-    public CreateTargetVariationExperimentDialog() : this(null) { }
-    public CreateTargetVariationExperimentDialog(IAlgorithm alg) {
-      InitializeComponent();
-
-      var problem = alg.Problem as IDataAnalysisProblem;
-      var inputCount = problem.ProblemData.AllowedInputVariables.Count() - 1; // -1 because one will be the target
-      if (combinationGroupSizeNumericUpDown.Value > inputCount)
-        combinationGroupSizeNumericUpDown.Value = inputCount;
-      var combinationGroupSize = (int)combinationGroupSizeNumericUpDown.Value;
-      combinationCountLabel.Text = ((inputCount + 1) * EnumerableExtensions.BinomialCoefficient(inputCount, combinationGroupSize)).ToString();
-
-      Experiment = null;
-      okButton.Enabled = alg != null;
-    }
-
-    public static IEnumerable<IOptimizer> CreateVariableCombinations(IAlgorithm algorithm, int combinationGroupSize, int repetitions) {
-      if (algorithm == null)
-        throw new ArgumentNullException("The algorithm parameter must be a valid IAlgorithm instance.");
-
-      var problem = (IDataAnalysisProblem)algorithm.Problem;
-      var problemData = problem.ProblemData;
-
-      var variables = problemData.AllowedInputVariables.ToList();
-      int count = 1;
-      foreach (var target in variables) {
-        var inputs = variables.Where(x => x != target).ToList();
-        var combinations = inputs.Combinations(combinationGroupSize);
-
-        foreach (var combination in combinations) {
-          var h = new HashSet<string>(combination);
-          var alg = (IAlgorithm)algorithm.Clone();
-          alg.Name += " {Target = " + target + ", Inputs = (" + combination.Aggregate((a, b) => a + "," + b) + ")}";
-          problem = (IDataAnalysisProblem)alg.Problem;
-          problemData = problem.ProblemData;
-          foreach (var item in problemData.InputVariables) {
-            problemData.InputVariables.SetItemCheckedState(item, h.Contains(item.Value));
-          }
-          SetTargetName(problemData, target);
-
-          var batchRun = new BatchRun(string.Format("Batchrun {0}", count++)) {
-            Repetitions = repetitions,
-            Optimizer = alg
-          };
-          yield return batchRun;
-        }
-      }
-    }
-
-    private static string GetTargetName(IDataAnalysisProblemData problemData) {
-      var regressionProblemData = problemData as IRegressionProblemData;
-      if (regressionProblemData != null)
-        return regressionProblemData.TargetVariable;
-      var classificationProblemData = problemData as IClassificationProblemData;
-      if (classificationProblemData != null)
-        return classificationProblemData.TargetVariable;
-      throw new ArgumentException("The provided argument must be either a regression or classification problem data.");
-    }
-
-    private static void SetTargetName(IDataAnalysisProblemData problemData, string targetName) {
-      var regressionProblemData = problemData as IRegressionProblemData;
-      if (regressionProblemData != null) {
-        regressionProblemData.TargetVariable = targetName;
-        return;
-      }
-      var classificationProblemData = problemData as IClassificationProblemData;
-      if (classificationProblemData != null) {
-        classificationProblemData.TargetVariable = targetName;
-        return;
-      }
-      throw new ArgumentException("The provided argument must be either a regression or classification problem data.");
-    }
-
-    #region events
-    private void CreateTargetVariationExperimentDialog_FormClosing(object sender, FormClosingEventArgs e) {
-      if (worker.IsBusy) {
-        if (DialogResult != DialogResult.OK) {
-          if (worker.IsBusy) worker.CancelAsync();
-        }
-        e.Cancel = true;
-      }
-    }
-
-    private void repetitionsNumericUpDown_Validated(object sender, EventArgs e) {
-      if (repetitionsNumericUpDown.Text == string.Empty)
-        repetitionsNumericUpDown.Text = repetitionsNumericUpDown.Value.ToString();
-    }
-
-    private void combinationGroupSizeNumericUpDown_Validating(object sender, System.ComponentModel.CancelEventArgs e) {
-      IContentView activeView = MainFormManager.MainForm.ActiveView as IContentView;
-      if (activeView == null) return;
-      var algorithm = (IAlgorithm)activeView.Content;
-      var problem = algorithm.Problem as IDataAnalysisProblem;
-      if (problem == null) return;
-      var inputCount = problem.ProblemData.AllowedInputVariables.Count() - 1;
-      if (combinationGroupSizeNumericUpDown.Value > inputCount)
-        combinationGroupSizeNumericUpDown.Value = inputCount;
-    }
-
-    private void combinationGroupSizeNumericUpDown_Validated(object sender, EventArgs e) {
-      if (combinationGroupSizeNumericUpDown.Text == string.Empty)
-        combinationGroupSizeNumericUpDown.Text = combinationGroupSizeNumericUpDown.Value.ToString();
-
-      IContentView activeView = MainFormManager.MainForm.ActiveView as IContentView;
-      if (activeView == null) return;
-      var algorithm = (IAlgorithm)activeView.Content;
-      var problem = (IDataAnalysisProblem)algorithm.Problem;
-      var inputCount = problem.ProblemData.AllowedInputVariables.Count() - 1;
-      if (combinationGroupSizeNumericUpDown.Value > inputCount)
-        combinationGroupSizeNumericUpDown.Value = inputCount;
-      combinationCountLabel.Text = ((inputCount + 1) * EnumerableExtensions.BinomialCoefficient(inputCount, (int)combinationGroupSizeNumericUpDown.Value)).ToString();
-    }
-
-    private void worker_DoWork(object sender, DoWorkEventArgs e) {
-      IContentView activeView = (IContentView)MainFormManager.MainForm.ActiveView;
-      var algorithm = (IAlgorithm)activeView.Content;
-      var problem = (IDataAnalysisProblem)algorithm.Problem;
-      var experiment = new Experiment("Target Variation Experiment");
-      var repetitions = (int)repetitionsNumericUpDown.Value;
-      var inputCount = problem.ProblemData.AllowedInputVariables.Count() - 1;
-      var combinationGroupSize = (int)combinationGroupSizeNumericUpDown.Value;
-      var totalNumberOfCombinations = (inputCount + 1) * EnumerableExtensions.BinomialCoefficient(inputCount, combinationGroupSize);
-      int progress = 0;
-      try {
-        foreach (var optimizer in CreateVariableCombinations(algorithm, combinationGroupSize, repetitions)) {
-          if (worker.CancellationPending)
-            throw new OperationCanceledException();
-          experiment.Optimizers.Add(optimizer);
-          progress++;
-          worker.ReportProgress((int)Math.Round(100d * progress / totalNumberOfCombinations));
-        }
-        Experiment = experiment;
-      } catch (OperationCanceledException) {
-        e.Cancel = true;
-        UpdateProgress(0);
-        progressBar.Visible = false;
-        okButton.Enabled = true;
-        combinationsLabel.Visible = true;
-        combinationCountLabel.Visible = true;
-      }
-    }
-
-    private void worker_ProgressChanged(object sender, ProgressChangedEventArgs e) {
-      if (InvokeRequired) {
-        Invoke((Action<int>)UpdateProgress, e.ProgressPercentage);
-      } else {
-        UpdateProgress(e.ProgressPercentage);
-      }
-    }
-
-    private void UpdateProgress(int percentage) {
-      progressBar.Value = percentage;
-    }
-
-    private void worker_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e) {
-      if (e.Cancelled || e.Error != null)
-        return;
-      DialogResult = DialogResult.OK;
-      Close();
-    }
-
-    private void okButton_Click(object sender, EventArgs args) {
-      IContentView activeView = MainFormManager.MainForm.ActiveView as IContentView;
-      if ((activeView != null) && (activeView.Content != null) && (activeView.Content is IAlgorithm) && !activeView.Locked) {
-        okButton.Enabled = false;
-        combinationsLabel.Visible = false;
-        combinationCountLabel.Visible = false;
-        progressBar.Visible = true;
-        worker.RunWorkerAsync();
-      }
-    }
-
-    private void cancelButton_Click(object sender, EventArgs e) {
-      if (worker.IsBusy)
-        worker.CancelAsync();
-    }
-    #endregion
-  }
-}
Index: branches/2288_HeuristicLab.VariableInteractionNetworks/HeuristicLab.VariableInteractionNetworks/3.3/HeuristicLab.VariableInteractionNetworks-3.3.csproj
===================================================================
--- branches/HeuristicLab.VariableInteractionNetworks/HeuristicLab.VariableInteractionNetworks/3.3/HeuristicLab.VariableInteractionNetworks-3.3.csproj	(revision 15421)
+++ branches/2288_HeuristicLab.VariableInteractionNetworks/HeuristicLab.VariableInteractionNetworks/3.3/HeuristicLab.VariableInteractionNetworks-3.3.csproj	(revision 15929)
@@ -17,5 +17,5 @@
     <DebugType>full</DebugType>
     <Optimize>false</Optimize>
-    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
+    <OutputPath>..\..\..\..\trunk\bin\</OutputPath>
     <DefineConstants>DEBUG;TRACE</DefineConstants>
     <ErrorReport>prompt</ErrorReport>
@@ -25,5 +25,5 @@
     <DebugType>pdbonly</DebugType>
     <Optimize>true</Optimize>
-    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
+    <OutputPath>..\..\..\..\trunk\bin\</OutputPath>
     <DefineConstants>TRACE</DefineConstants>
     <ErrorReport>prompt</ErrorReport>
@@ -38,5 +38,5 @@
   <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Debug|x64'">
     <DebugSymbols>true</DebugSymbols>
-    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
+    <OutputPath>..\..\..\..\trunk\bin\</OutputPath>
     <DefineConstants>DEBUG;TRACE</DefineConstants>
     <DebugType>full</DebugType>
@@ -46,5 +46,5 @@
   </PropertyGroup>
   <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Release|x64'">
-    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
+    <OutputPath>..\..\..\..\trunk\bin\</OutputPath>
     <DefineConstants>TRACE</DefineConstants>
     <Optimize>true</Optimize>
@@ -56,5 +56,5 @@
   <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Debug|x86'">
     <DebugSymbols>true</DebugSymbols>
-    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
+    <OutputPath>..\..\..\..\trunk\bin\</OutputPath>
     <DefineConstants>DEBUG;TRACE</DefineConstants>
     <DebugType>full</DebugType>
@@ -64,5 +64,5 @@
   </PropertyGroup>
   <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Release|x86'">
-    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
+    <OutputPath>..\..\..\..\trunk\bin\</OutputPath>
     <DefineConstants>TRACE</DefineConstants>
     <Optimize>true</Optimize>
@@ -192,11 +192,4 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="CreateTargetVariationExperiment.cs" />
-    <Compile Include="CreateTargetVariationExperimentDialog.cs">
-      <SubType>Form</SubType>
-    </Compile>
-    <Compile Include="CreateTargetVariationExperimentDialog.Designer.cs">
-      <DependentUpon>CreateTargetVariationExperimentDialog.cs</DependentUpon>
-    </Compile>
     <Compile Include="INetworkNode.cs" />
     <Compile Include="Plugin.cs" />